/*
 * All content copyright (c) 2003-2009 Terracotta, Inc., except as may otherwise be noted in a separate copyright notice.  All rights reserved.
 */
Ext.BLANK_IMAGE_URL = 'extjs/resources/images/default/s.gif';
Ext.chart.Chart.CHART_URL = 'extjs/resources/charts.swf';

// Uncomment this and set the name of a component for which to observe events in the Firebug console.
//Ext.util.Observable.capture(Ext.getCmp('my-comp'), console.info);

var simpleAuthentication;

Ext.onReady(function() {
    if (Ext.isIE) {
        //alert("Internet Explorer isn't a support browser, please use Mozilla Firefox instead: http://www.getfirefox.net")
    }

    Ext.QuickTips.init();
    Ext.state.Manager.setProvider(new Ext.state.CookieProvider({
        expires: new Date(new Date().getTime() + (1000 * 60 * 60 * 24 * 365 * 1)) // 1 year
    }));

    createAuthenticationInterface();
    authenticate();
});

var authenticate = function() {
    simpleAuthentication.hide();

    var userName = Ext.getCmp('userName').getValue();
    var passwd = Ext.getCmp('passwd').getValue();

    Ext.Ajax.extraParams = {
        user: userName,
        password: passwd
    };

    startOrAuth();
};

function createAuthenticationInterface() {
    simpleAuthentication = new Ext.Window({
        closable: false,
        initHidden: true,
        title: 'Authentication required',
        modal: true,
        resizable: false,
        listeners: {
            'show' : function() {
                var passwdField = Ext.getCmp('passwd');
                if(passwdField.getValue().length == 0) {
                    Ext.getCmp('userName').focus(true, 200);
                } else {
                    passwdField.focus(true, 200);
                }
            }
        }
    });

    var onEnter = function(f, e) {
        if(e.getKey() == 13) {
            authenticate();
        }
    };

    var form = new Ext.FormPanel({
        labelWidth: 100, // label settings here cascade unless overridden
        frame: true,
        bodyStyle: 'padding: 5px 5px 0',
        width: 350,
        modal: true,

        items: [
            {
                xtype: 'textfield',
                fieldLabel: 'User Name',
                id: 'userName',
                allowBlank: false,
                listeners: {
                    specialkey: onEnter
                }
            },
            {
                xtype: 'textfield',
                fieldLabel: 'Password',
                id: 'passwd',
                inputType: 'password',
                allowBlank: false,
                listeners: {
                    specialkey: onEnter
                }
            }
        ],

        buttons: [
            {
                text: 'Ok',
                listeners: {
                    'click': authenticate
                }
            }
        ]
    });

    simpleAuthentication.add(form);
    simpleAuthentication.render(document.body);
}

function startOrAuth() {
    Ext.Ajax.request({
        url: '/monitor/isSecured',
        failure: function(response) {
            if (401 == response.status) {
                simpleAuthentication.show();
            } else {
                alert("Couldn't access the Ehcache DX REST functionalities.")
            }
        },
        success: function(response) {
            simpleAuthentication.hide();

            Ext.Ajax.request({
                url: '/monitor/isLicensed',
                failure: function(response, opts) {
                    opts.displayLicenseText(false);
                },
                success: function(response, opts) {
                    opts.displayLicenseText('true' == response.responseText);
                },
                displayLicenseText: function(isLicensed) {
                    var detected = Ext.get('license-key-detected');
                    detected.setVisible(isLicensed);

                    var notDetected = Ext.get('license-key-not-detected');
                    notDetected.enableDisplayMode('block');
                    notDetected.setVisible(!isLicensed);
                }
            });
            
            Ext.Ajax.request({
                url: '/monitor/getSamplingSeconds',
                failure: function(response) {
                    if (401 == response.status) {
                        simpleAuthentication.show();
                    } else {
                        alert("Couldn't access the Ehcache DX REST functionalities.")
                    }
                },
                success: function(response) {
                    var samplingSeconds = response.responseText;
                    var updateMillis = samplingSeconds * 1000;
                    var monitor = new TC.monitor.Main();

                    Ext.Updater.defaults.showLoadIndicator = false;
                    Ext.TaskMgr.start({
                        run: function() {
                            monitor.updateData(updateMillis);
                        },
                        interval: updateMillis
                    });
                }
            });
        }
    });
}
